package jpatest

import _root_.javax.persistence._

case class Role4Key(var user_id: Int, var proj_id: Int) {
  def this() = this(0,0)
}

@Entity
@IdClass(classOf[Role4Key])
@Table{ val name="roles4" }
class Role4(name: String) {

  def this() = this("")

  @Id
  @Column{val name ="user_id", val nullable=false,
	  val updatable=false, val insertable=false}
  var user_id: Int = _

  @Id
  @Column{val name ="proj_id", val nullable=false,
	  val updatable=false, val insertable=false}
  var proj_id: Int = _

  @Version
  var version : Int = _

  var title : String = name

  @ManyToOne{val cascade = Array(CascadeType.ALL),
	     val targetEntity = classOf[User4],
	     val fetch = FetchType.LAZY }
  @JoinColumn{val name = "user_id"}
  var user: User4 = _

  @ManyToOne{val cascade = Array(CascadeType.ALL),
	     val targetEntity = classOf[Project4],
	     val fetch = FetchType.LAZY }
  @JoinColumn{val name = "proj_id"}
  var project: Project4 = _
}
